<?php

namespace Teknisa\MAN\Services;

use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;
use Teknisa\MAN\Services;
use \Setforms2\Shared\ORM\DateTime;
use \Zeedhi\Framework\Util\Functions;

class LayoutImportacaoService {
	
	protected $entityManager;
	protected $util;
	protected $boImpMercadoBoca;
	protected $evoluiSaldoService;
	protected $criptoPasswordUrl;
    protected $xmlSchemaUrl;
    protected $novoCodigo;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager, $util, Services\NovoCodigo $NovoCodigo)  {
		$this->entityManager = $entityManager;
		$this->util = $util;
    $this->novoCodigo = $NovoCodigo;
	}
	
	public function findAjustaSaldo ($CDFILIAL) {
		$sql = "SELECT IDAJUSALDIMPCON FROM PARAVEND
    			  WHERE CDFILIAL = :CDFILIAL";
    $params = [
        ':CDFILIAL' => $CDFILIAL
    ];
    return $this->entityManager->getConnection()->fetchOne($sql, $params);
	}
	
	// LAYOUTIMP
	
	public function findLayouts ($CDFILIAL) {
    $TCDFILIAL = 'T';
    
    if ($CDFILIAL) {
        $TCDFILIAL = '';
    }

		$sql = "SELECT
             L.CDLAYOUTIMP, L.NMLAYOUTIMP, L.IDSEPARCAMPO, L.IDCARACDELIM,
             L.IDCARACDECIM, L.IDCARACSTRIN, L.IDSISTEMAIMP, L.IDSISTEMORIG,
             L.CDFILIAL, L.DSDIRARQIMPCONS, L.IDPERIODIMPCONS, L.HRIMPAUTOCONS,
             L.IDTPCLIEIMPCONS, L.CDCLIEIMPCONS, L.DSDIRARQPHP, L.DSDIRINSTALAPHP,
             C.NMRAZSOCCLIE, C.NRINSJURCLIE
          FROM
             LAYOUTIMP L, CLIENTE C
          WHERE
             (L.IDSISTEMORIG = 'PDV') AND
             (L.CDCLIEIMPCONS = C.CDCLIENTE(+)) AND
             ((L.CDFILIAL = :P_CDFILIAL) OR (:P_TCDFILIAL = 'T'))
          ORDER BY
             L.CDLAYOUTIMP";
                   
    $params = [
        ':P_CDFILIAL' => $CDFILIAL,
        ':P_TCDFILIAL' => $TCDFILIAL
    ];
    
    return $this->entityManager->getConnection()->fetchAll($sql, $params);
	}
	
	public function updateLayout ($conditions) {
		$sql = "update LAYOUTIMP
            set
              NMLAYOUTIMP = :NMLAYOUTIMP,
              IDSEPARCAMPO = :IDSEPARCAMPO,
              IDCARACDELIM = :IDCARACDELIM,
              IDCARACDECIM = :IDCARACDECIM,
              IDCARACSTRIN = :IDCARACSTRIN,
              IDSISTEMAIMP = :IDSISTEMAIMP,
              IDSISTEMORIG = :IDSISTEMORIG,
              CDFILIAL     = :CDFILIAL,
              DSDIRARQIMPCONS = :DSDIRARQIMPCONS,
              IDPERIODIMPCONS = :IDPERIODIMPCONS,
              HRIMPAUTOCONS   = :HRIMPAUTOCONS,
              IDTPCLIEIMPCONS = :IDTPCLIEIMPCONS,
              CDCLIEIMPCONS   = :CDCLIEIMPCONS,
              DSDIRARQPHP     = :DSDIRARQPHP,
              DSDIRINSTALAPHP = :DSDIRINSTALAPHP
            where
              CDLAYOUTIMP = :OLD_CDLAYOUTIMP";
               
    $params = [
          ':NMLAYOUTIMP' => $conditions['NMLAYOUTIMP'],
          ':IDSEPARCAMPO' => $conditions['IDSEPARCAMPO'],
          ':IDCARACDELIM' => $conditions['IDCARACDELIM'],
          ':IDCARACDECIM' => $conditions['IDCARACDECIM'],
          ':IDCARACSTRIN' => $conditions['IDCARACSTRIN'],
          ':IDSISTEMAIMP' => $conditions['IDSISTEMAIMP'],
          ':IDSISTEMORIG' => $conditions['IDSISTEMORIG'],
          ':CDFILIAL' => $conditions['CDFILIAL'],
          ':DSDIRARQIMPCONS' => $conditions['DSDIRARQIMPCONS'],
          ':IDPERIODIMPCONS' => $conditions['IDPERIODIMPCONS'],
          ':HRIMPAUTOCONS' => $conditions['HRIMPAUTOCONS'],
          ':IDTPCLIEIMPCONS' => $conditions['IDTPCLIEIMPCONS'],
          ':CDCLIEIMPCONS' => $conditions['CDCLIEIMPCONS'],
          ':DSDIRARQPHP' => $conditions['DSDIRARQPHP'],
          ':DSDIRINSTALAPHP' => $conditions['DSDIRINSTALAPHP'],
          ':OLD_CDLAYOUTIMP' => $conditions['CDLAYOUTIMP']
      ];
  
    return $this->entityManager->getConnection()->executeQuery($sql, $params);
	}
	
	public function addLayout($conditions) {
    $sql = "INSERT INTO LAYOUTIMP
              (CDLAYOUTIMP, NMLAYOUTIMP, IDSEPARCAMPO, IDCARACDELIM,
               IDCARACDECIM, IDCARACSTRIN, IDSISTEMAIMP, IDSISTEMORIG,
               CDFILIAL)
            VALUES
              (:CDLAYOUTIMP, :NMLAYOUTIMP, :IDSEPARCAMPO, :IDCARACDELIM,
               :IDCARACDECIM, :IDCARACSTRIN, :IDSISTEMAIMP, :IDSISTEMORIG,
               :CDFILIAL)";
               
    $params = [
        ':CDLAYOUTIMP' => $conditions['CDLAYOUTIMP'],
        ':NMLAYOUTIMP' => $conditions['NMLAYOUTIMP'],
        ':IDSEPARCAMPO' => $conditions['IDSEPARCAMPO'],
        ':IDCARACDELIM' => isset($conditions['IDCARACDELIM']) ? $conditions['IDCARACDELIM'] : null,
        ':IDCARACDECIM' => isset($conditions['IDCARACDECIM']) ? $conditions['IDCARACDECIM'] : null,
        ':IDCARACSTRIN' => isset($conditions['IDCARACSTRIN']) ? $conditions['IDCARACSTRIN'] : null,
        ':IDSISTEMAIMP' => isset($conditions['IDSISTEMAIMP']) ? $conditions['IDSISTEMAIMP'] : null,
        ':IDSISTEMORIG' => 'PDV',
        ':CDFILIAL' => isset($conditions['CDFILIAL']) ? $conditions['CDFILIAL'] : null
    ];
    
    return $this->entityManager->getConnection()->executeQuery($sql, $params);
  }
	
	public function deleteLayout($conditions) {
      $sql = "DELETE from LAYOUTIMP
              WHERE CDLAYOUTIMP = :OLD_CDLAYOUTIMP";
                 
      $params = [
          ':OLD_CDLAYOUTIMP' => $conditions['CDLAYOUTIMP']
      ];
      
      return $this->entityManager->getConnection()->executeQuery($sql, $params);
  }
  
  // TABLAYOUTIMP
  
  public function findArquivos ($CDLAYOUTIMP) {
	  $sql = "SELECT
                TB.CDLAYOUTIMP, TB.NRSEQTABELAY, TB.NMARQLAYIMP,
                TB.NMTABELABD, TA.DSTABELABD, TB.NRORDIMPLAY
              FROM
                TABLAYOUTIMP TB, TABELA TA
              WHERE
                TB.CDLAYOUTIMP = :P_CDLAYOUTIMP AND
                TB.NMTABELABD = TA.NMTABELABD(+)
              ORDER BY
                TB.NRORDIMPLAY";
                 
    $params = [
        ':P_CDLAYOUTIMP' => $CDLAYOUTIMP
    ];
    
    return $this->entityManager->getConnection()->fetchAll($sql, $params);
	}
	
  public function addConfig($conditions) {
    $sql = "INSERT INTO TABLAYOUTIMP
              (CDLAYOUTIMP, NRSEQTABELAY, NMARQLAYIMP, NMTABELABD, 
            NRORDIMPLAY)
            VALUES
              (:CDLAYOUTIMP, :NRSEQTABELAY, :NMARQLAYIMP, :NMTABELABD, 
            :NRORDIMPLAY)";
            
    // pega novo codigo
    $CDLAYOUTIMP = $conditions['CDLAYOUTIMP'];
    $contador = 'TABLAYOUTIMP' . $CDLAYOUTIMP;
    $NRSEQTABELAY = $this->novoCodigo->getCodeByTableName($contador, NULL);
               
    $params = [
        ':CDLAYOUTIMP' => $conditions['CDLAYOUTIMP'],
        ':NRSEQTABELAY' => $NRSEQTABELAY,
        ':NMARQLAYIMP' => $conditions['NMARQLAYIMP'],
        ':NMTABELABD' => null,
        ':NRORDIMPLAY' => null
    ];
    
    return $this->entityManager->getConnection()->executeQuery($sql, $params);
  }
    
  public function updateConfig($conditions) {
    $sql = "UPDATE TABLAYOUTIMP
            SET
              NMARQLAYIMP = :NMARQLAYIMP,
              NMTABELABD = :NMTABELABD,
              NRORDIMPLAY = :NRORDIMPLAY
            WHERE
              CDLAYOUTIMP = :OLD_CDLAYOUTIMP
              AND NRSEQTABELAY = :OLD_NRSEQTABELAY
    ";

    $params = [
        ':OLD_CDLAYOUTIMP' => $conditions['CDLAYOUTIMP'],
        ':OLD_NRSEQTABELAY' => $conditions['NRSEQTABELAY'],
        ':NMARQLAYIMP' => $conditions['NMARQLAYIMP'],
        ':NMTABELABD' => null,
        ':NRORDIMPLAY' => null
    ];
    
    return $this->entityManager->getConnection()->executeQuery($sql, $params);
  }
    
  public function deleteConfig($conditions) {
    $sql = "DELETE FROM TABLAYOUTIMP
            WHERE
              CDLAYOUTIMP = :OLD_CDLAYOUTIMP
              AND NRSEQTABELAY = :OLD_NRSEQTABELAY
    ";
               
    $params = [
        ':OLD_CDLAYOUTIMP' => $conditions['CDLAYOUTIMP'],
        ':OLD_NRSEQTABELAY' => $conditions['NRSEQTABELAY']
    ];
    
    return $this->entityManager->getConnection()->executeQuery($sql, $params);
  }
    
  // FUNLAYOUTIMP
    
  public function findFuncoes ($conditions) {
		  $sql = "SELECT
                  CDLAYOUTIMP, NRSEQTABELAY, IDFUNARQLAY, IDINACONSARQIMP, IDPARALISAIMPARQ, IDREMOVEZEROESQ
                FROM
                  FUNLAYOUTIMP
                WHERE
                  (CDLAYOUTIMP  = :P_CDLAYOUTIMP ) AND
                  (NRSEQTABELAY = :P_NRSEQTABELAY) AND
                  (IDFUNARQLAY  = :P_IDFUNARQLAY OR :P_TIDFUNARQLAY = 'T')";
                   
	    $params = [
	        ':P_CDLAYOUTIMP'  => $conditions['CDLAYOUTIMP'],
	        ':P_NRSEQTABELAY' => $conditions['NRSEQTABELAY'],
	        'P_IDFUNARQLAY'   => '008', // busca somente cadastro de consumidores
	        ':P_TIDFUNARQLAY' => null
	    ];
	    
	    return $this->entityManager->getConnection()->fetchAll($sql, $params);
	}
	
	public function addFuncao ($conditions) {
	   $sql = "insert into FUNLAYOUTIMP
                (CDLAYOUTIMP, NRSEQTABELAY, IDFUNARQLAY, IDINACONSARQIMP, IDPARALISAIMPARQ, IDREMOVEZEROESQ)
              values
                (:CDLAYOUTIMP, :NRSEQTABELAY, :IDFUNARQLAY, :IDINACONSARQIMP, :IDPARALISAIMPARQ, :IDREMOVEZEROESQ)";

      $params = [
          ':CDLAYOUTIMP' => $conditions['CDLAYOUTIMP'],
          ':NRSEQTABELAY' => $conditions['NRSEQTABELAY'],
          ':IDFUNARQLAY' => $conditions['IDFUNARQLAY'],
          ':IDINACONSARQIMP' => $conditions['IDINACONSARQIMP'],
          ':IDPARALISAIMPARQ' => $conditions['IDPARALISAIMPARQ'],
          ':IDREMOVEZEROESQ' => $conditions['IDREMOVEZEROESQ']
      ];
      
      $this->entityManager->getConnection()->executeQuery($sql, $params);
      
      // insercao automatica em COLLAYOUTIMP
      // caso futuramente forem adicionadas outras funcoes, adicionar aqui a verificacao de IDFUNAQRLAY 
      // para definir o nome da tabela
      $nomeTabela = 'CONSUMIDOR'; 
      $this->insertCollayoutImp($conditions['CDLAYOUTIMP'], $conditions['NRSEQTABELAY'], $conditions['IDFUNARQLAY'], $nomeTabela);
	}
	
	public function updateFuncao($conditions) {
    $sql = "UPDATE FUNLAYOUTIMP
            SET
              CDLAYOUTIMP      = :CDLAYOUTIMP,
              NRSEQTABELAY     = :NRSEQTABELAY,
              IDFUNARQLAY      = :IDFUNARQLAY,
              IDINACONSARQIMP  = :IDINACONSARQIMP,
              IDPARALISAIMPARQ = :IDPARALISAIMPARQ,
              IDREMOVEZEROESQ  = :IDREMOVEZEROESQ
            WHERE
              CDLAYOUTIMP  = :OLD_CDLAYOUTIMP
              AND NRSEQTABELAY = :OLD_NRSEQTABELAY
              AND IDFUNARQLAY  = :OLD_IDFUNARQLAY
    ";

    $params = [
      ':CDLAYOUTIMP' => $conditions['CDLAYOUTIMP'],
      ':NRSEQTABELAY' => $conditions['NRSEQTABELAY'],
      ':IDFUNARQLAY' => $conditions['IDFUNARQLAY'],
      ':IDINACONSARQIMP' => $conditions['IDINACONSARQIMP'],
      ':IDPARALISAIMPARQ' => $conditions['IDPARALISAIMPARQ'],
      ':IDREMOVEZEROESQ' => $conditions['IDREMOVEZEROESQ'],
      ':OLD_CDLAYOUTIMP' => $conditions['CDLAYOUTIMP'],
      ':OLD_NRSEQTABELAY' => $conditions['NRSEQTABELAY'],
      ':OLD_IDFUNARQLAY' => $conditions['IDFUNARQLAY']
    ];
      
    return $this->entityManager->getConnection()->executeQuery($sql, $params);
  }
  
  public function deleteFuncao($conditions) {
    $sql = "DELETE FROM FUNLAYOUTIMP
            WHERE
              CDLAYOUTIMP  = :OLD_CDLAYOUTIMP
              AND NRSEQTABELAY = :OLD_NRSEQTABELAY
              AND IDFUNARQLAY  = :OLD_IDFUNARQLAY";

    $params = [
        ':OLD_CDLAYOUTIMP' => $conditions['CDLAYOUTIMP'],
        ':OLD_NRSEQTABELAY' => $conditions['NRSEQTABELAY'],
        ':OLD_IDFUNARQLAY' => $conditions['IDFUNARQLAY']
    ];
    
    $this->entityManager->getConnection()->executeQuery($sql, $params);
  }
  
  // COLLAYOUTIMP

	public function insertCollayoutImp($CDLAYOUTIMP, $NRSEQTABELAY, $IDFUNARQLAY, $nomeTabela) {
      $colunas = $this->getColunas($nomeTabela);
  
      foreach($colunas as $coluna) {
        // ignorar colunas IDSITCONSUMI e IDVERSALDCON
        if (($nomeTabela == 'CONSUMIDOR' && in_array($coluna['NMCOLUNA'], ['IDSITCONSUMI', 'IDVERSALDCON']))) {
            continue;
        }

        $sql = "INSERT INTO COLLAYOUTIMP
                (CDLAYOUTIMP, NRSEQTABELAY, IDFUNARQLAY, NRSEQCOLULAY, NMTABELAIMP, NMCOLUNAIMP,
                 NRPOSICOLLAY, NRTAMCOLLAY, NRCASASDECIM, CDFRMTCOLLAY, IDGERSEQCOLU, IDTDADCOLLAY,
                 IDGERCODCOLU, DSDEFACOLLAY, DSCONCATESQ, DSCONCATDIR)
                VALUES
                (:CDLAYOUTIMP, :NRSEQTABELAY, :IDFUNARQLAY, :NRSEQCOLULAY, :NMTABELAIMP, :NMCOLUNAIMP,
                 :NRPOSICOLLAY, :NRTAMCOLLAY, :NRCASASDECIM, :CDFRMTCOLLAY, :IDGERSEQCOLU, :IDTDADCOLLAY,
                 :IDGERCODCOLU, :DSDEFACOLLAY, :DSCONCATESQ, :DSCONCATDIR)";

        $params = [
          ':CDLAYOUTIMP' => $CDLAYOUTIMP,
          ':NRSEQTABELAY' => $NRSEQTABELAY,
          ':IDFUNARQLAY' => $IDFUNARQLAY,
          ':NRSEQCOLULAY' => $this->getNextSeqColLayoutImp($CDLAYOUTIMP, $NRSEQTABELAY, $IDFUNARQLAY),
          ':NMTABELAIMP' => $coluna['NMTABELABD'],
          ':NMCOLUNAIMP' => $coluna['NMCOLUNA'],
          ':NRPOSICOLLAY' => null,
          ':NRTAMCOLLAY' => null,
          ':NRCASASDECIM' => null,
          ':CDFRMTCOLLAY' => null,
          ':IDGERSEQCOLU' => 'N',
          ':IDTDADCOLLAY' => $coluna['IDTIPOCOLUNA'],
          ':IDGERCODCOLU' => 'N',
          ':DSDEFACOLLAY' => null,
          ':DSCONCATESQ' => null,
          ':DSCONCATDIR' => null,
        ];

          $this->entityManager->getConnection()->executeQuery($sql, $params);
      }
  }
  
  private function getNextSeqColLayoutImp($CDLAYOUTIMP, $NRSEQTABELAY, $IDFUNARQLAY) {
      $contador = 'COLLAYOUTIMP' . $CDLAYOUTIMP . $NRSEQTABELAY . $IDFUNARQLAY;
      return $this->novoCodigo->getCodeByTableName($contador, NULL);
  }

	
	public function getColunas ($nomeTabela) {
    $sql = "SELECT
              NMTABELABD, NMCOLUNA, IDTIPOCOLUNA, NRTAMANHOCOL, IDCRIADOCOL,
              IDCOLUNANULL, DSCOLUNA, IDPRIMARY, IDCOLUNAIMP
            FROM
              COLUNA
            WHERE
              NMTABELABD = :P_NMTABELABD
              AND IDCOLUNAIMP = 'S'";
                 
    $params = [
        ':P_NMTABELABD'  => $nomeTabela
    ];
    
    return $this->entityManager->getConnection()->fetchAll($sql, $params);
	}
  
   public function findColunas ($conditions) {
		  $sql = "SELECT
                CO.NMTABELABD, CO.NMCOLUNA, CO.IDTIPOCOLUNA, CO.IDCOLUNANULL, CO.DSCOLUNA, CO.IDPRIMARY,
                CO.NRTAMANHOCOL, CL.CDLAYOUTIMP, CL.NRSEQTABELAY, CL.IDFUNARQLAY, CL.NRSEQCOLULAY,
                CL.NRPOSICOLLAY, CL.NRTAMCOLLAY, CL.NRCASASDECIM, CL.CDFRMTCOLLAY, CL.NMCOLUNAIMP,
                CL.DSDEFACOLLAY, CL.IDGERSEQCOLU, CL.IDGERCODCOLU, CL.IDTDADCOLLAY, FO.DSFRMTCOLLAY,
                CL.NMTABELAIMP, CL.NMCOLUNAAUX, CL.DSCONCATESQ, CL.DSCONCATDIR
              FROM
                FRMTCOLLAY FO, COLUNA CO, COLLAYOUTIMP CL
              WHERE
                CL.CDLAYOUTIMP    = :P_CDLAYOUTIMP AND
                CL.NRSEQTABELAY   = :P_NRSEQTABELAY AND
                CL.IDFUNARQLAY    = :P_IDFUNARQLAY AND
                CL.NMTABELAIMP(+) = CO.NMTABELABD AND
                CL.NMCOLUNAIMP(+) = CO.NMCOLUNA AND
                CL.CDFRMTCOLLAY   = FO.CDFRMTCOLLAY(+) AND
                CO.IDCRIADOCOL    = 'S'
      ";
                   
	    $params = [
	        ':P_CDLAYOUTIMP'  => $conditions['CDLAYOUTIMP'],
	        ':P_NRSEQTABELAY' => $conditions['NRSEQTABELAY'],
	        ':P_IDFUNARQLAY'   => $conditions['IDFUNARQLAY']
	    ];
	    
	    return $this->entityManager->getConnection()->fetchAll($sql, $params);
	}
	
	public function updateColuna ($conditions) {
    $sql = "UPDATE COLLAYOUTIMP
            SET
              NRPOSICOLLAY = :NRPOSICOLLAY,
              NRTAMCOLLAY = :NRTAMCOLLAY,
              NRCASASDECIM = :NRCASASDECIM,
              CDFRMTCOLLAY = :CDFRMTCOLLAY,
              NMCOLUNAIMP = :NMCOLUNAIMP,
              DSDEFACOLLAY = :DSDEFACOLLAY,
              IDGERSEQCOLU = :IDGERSEQCOLU,
              IDGERCODCOLU = :IDGERCODCOLU,
              IDTDADCOLLAY = :IDTDADCOLLAY,
              NMTABELAIMP = :NMTABELAIMP,
              NMCOLUNAAUX = :NMCOLUNAAUX,
              DSCONCATESQ = :DSCONCATESQ,
              DSCONCATDIR = :DSCONCATDIR
            WHERE
              CDLAYOUTIMP = :OLD_CDLAYOUTIMP AND
              NRSEQTABELAY = :OLD_NRSEQTABELAY AND
              IDFUNARQLAY = :OLD_IDFUNARQLAY AND
              NRSEQCOLULAY = :OLD_NRSEQCOLULAY
    ";

    $params = [
      ':NRPOSICOLLAY' => $conditions['NRPOSICOLLAY'],
      ':NRTAMCOLLAY' => $conditions['NRTAMCOLLAY'],
      ':NRCASASDECIM' => $conditions['NRCASASDECIM'],
      ':CDFRMTCOLLAY' => $conditions['CDFRMTCOLLAY'],
      ':NMCOLUNAIMP' => $conditions['NMCOLUNAIMP'],
      ':DSDEFACOLLAY' => $conditions['DSDEFACOLLAY'],
      ':IDGERSEQCOLU' => $conditions['IDGERSEQCOLU'],
      ':IDGERCODCOLU' => $conditions['IDGERCODCOLU'],
      ':IDTDADCOLLAY' => $conditions['IDTDADCOLLAY'],
      ':NMTABELAIMP' => $conditions['NMTABELAIMP'],
      ':NMCOLUNAAUX' => $conditions['NMCOLUNAAUX'],
      ':DSCONCATESQ' => $conditions['DSCONCATESQ'],
      ':DSCONCATDIR' => $conditions['DSCONCATDIR'],
      ':OLD_CDLAYOUTIMP' => $conditions['CDLAYOUTIMP'],
      ':OLD_NRSEQTABELAY' => $conditions['NRSEQTABELAY'],
      ':OLD_IDFUNARQLAY' => $conditions['IDFUNARQLAY'],
      ':OLD_NRSEQCOLULAY' => $conditions['NRSEQCOLULAY']
  ];
    
    return $this->entityManager->getConnection()->executeQuery($sql, $params);
	}
	
	public function deleteColuna($conditions) {
    $sql = "DELETE FROM COLLAYOUTIMP
            WHERE
              CDLAYOUTIMP = :OLD_CDLAYOUTIMP AND
              NRSEQTABELAY = :OLD_NRSEQTABELAY AND
              IDFUNARQLAY = :OLD_IDFUNARQLAY AND
              NRSEQCOLULAY = :OLD_NRSEQCOLULAY";

    $params = [
      ':OLD_CDLAYOUTIMP' => $conditions['CDLAYOUTIMP'],
      ':OLD_NRSEQTABELAY' => $conditions['NRSEQTABELAY'],
      ':OLD_IDFUNARQLAY' => $conditions['IDFUNARQLAY'],
      ':OLD_NRSEQCOLULAY' => $conditions['NRSEQCOLULAY']
    ];

    return $this->entityManager->getConnection()->executeQuery($sql, $params);
  }
  
  public function deleteMultiplasColunas(array $rows) {
      foreach ($rows as $row) {
          $this->deleteColuna($row);
      }
  }
  
  public function findColunasNaoCadastradas ($conditions) {
	  $sql = "SELECT
              CO.NMCOLUNA,
              CO.NMTABELABD,
              CO.IDTIPOCOLUNA
            FROM
              COLUNA CO
            WHERE
              CO.NMTABELABD = :P_NMTABELABD
              AND (CO.NMCOLUNA LIKE :P_NMCOLUNA OR :P_TNMCOLUNA = 'T')
              AND CO.IDCRIADOCOL = 'S'
              AND CO.NMCOLUNA NOT IN (
                SELECT
                  CL.NMCOLUNAIMP
                FROM
                  COLLAYOUTIMP CL
                WHERE
                  CL.CDLAYOUTIMP = :P_CDLAYOUTIMP
                  AND CL.NRSEQTABELAY = :P_NRSEQTABELAY
                  AND CL.NMTABELAIMP = CO.NMTABELABD
                  AND CL.NMCOLUNAIMP = CO.NMCOLUNA
              )
    ";
    
    $P_TNMCOLUNA = 'T';
    if (isset($conditions['NMCOLUNA'])) {
      $conditions['NMCOLUNA'] = strtoupper($conditions['NMCOLUNA']);
      $P_TNMCOLUNA = null;
    } else {
      $conditions['NMCOLUNA'] = null;
    }
    $nomeTabela = 'CONSUMIDOR'; // aqui tambem é necessaria uma verificacao se for utilizar mais funcoes alem de cadastro de consumidors
    $params = [
        ':P_CDLAYOUTIMP'  => $conditions['CDLAYOUTIMP'],
        ':P_NRSEQTABELAY' => $conditions['NRSEQTABELAY'],
        ':P_NMTABELABD'   => $nomeTabela,
        ':P_TNMCOLUNA'    => $P_TNMCOLUNA,
        ':P_NMCOLUNA'     => $conditions['NMCOLUNA']
    ];
    
    return $this->entityManager->getConnection()->fetchAll($sql, $params);
	}
	
	public function addColuna ($conditions) {
	  $sql = "INSERT INTO COLLAYOUTIMP
                (CDLAYOUTIMP, NRSEQTABELAY, IDFUNARQLAY, NRSEQCOLULAY, NMTABELAIMP, NMCOLUNAIMP,
                 NRPOSICOLLAY, NRTAMCOLLAY, NRCASASDECIM, CDFRMTCOLLAY, IDGERSEQCOLU, IDTDADCOLLAY,
                 IDGERCODCOLU, DSDEFACOLLAY, DSCONCATESQ, DSCONCATDIR)
                VALUES
                (:CDLAYOUTIMP, :NRSEQTABELAY, :IDFUNARQLAY, :NRSEQCOLULAY, :NMTABELAIMP, :NMCOLUNAIMP,
                 :NRPOSICOLLAY, :NRTAMCOLLAY, :NRCASASDECIM, :CDFRMTCOLLAY, :IDGERSEQCOLU, :IDTDADCOLLAY,
                 :IDGERCODCOLU, :DSDEFACOLLAY, :DSCONCATESQ, :DSCONCATDIR)";
    
    $CDLAYOUTIMP = $conditions['CDLAYOUTIMP'];
    $NRSEQTABELAY = $conditions['NRSEQTABELAY'];
    $IDFUNARQLAY = $conditions['IDFUNARQLAY'];
    
    $params = [
          ':CDLAYOUTIMP' => $CDLAYOUTIMP,
          ':NRSEQTABELAY' => $NRSEQTABELAY,
          ':IDFUNARQLAY' => $IDFUNARQLAY,
          ':NRSEQCOLULAY' => $this->getNextSeqColLayoutImp($CDLAYOUTIMP, $NRSEQTABELAY, $IDFUNARQLAY),
          ':NMTABELAIMP' => $conditions['NMTABELABD'],
          ':NMCOLUNAIMP' => $conditions['NMCOLUNA'],
          ':NRPOSICOLLAY' => $conditions['NRPOSICOLLAY'],
          ':NRTAMCOLLAY' => $conditions['NRTAMCOLLAY'],
          ':NRCASASDECIM' => $conditions['NRCASASDECIM'],
          ':CDFRMTCOLLAY' => isset($conditions['CDFRMTCOLLAY']) ? $conditions['CDFRMTCOLLAY'] : null,
          ':IDGERSEQCOLU' => 'N',
          ':IDTDADCOLLAY' => $conditions['IDTIPOCOLUNA'],
          ':IDGERCODCOLU' => 'N',
          ':DSDEFACOLLAY' => $conditions['DSDEFACOLLAY'],
          ':DSCONCATESQ' => $conditions['DSCONCATESQ'],
          ':DSCONCATDIR' => $conditions['DSCONCATDIR'],
        ];

          $this->entityManager->getConnection()->executeQuery($sql, $params);

	}
	
	public function findFormatos () {
	  $sql = "SELECT CDFRMTCOLLAY, DSFRMTCOLLAY
            FROM FRMTCOLLAY
            ORDER BY CDFRMTCOLLAY";
    
    return $this->entityManager->getConnection()->fetchAll($sql, []);
	}
	
	// validacoes importacao
	public function findValidacoes ($conditions) {
	  $sql = "SELECT
              CDLAYOUTIMP, NRSEQTABELAY, NRSEQVALLAY ,NRPOSINIVALLAY, NRTAMVALLAY ,DSVALVALLAY
            FROM
              VALLAYOUTIMP
            WHERE
              CDLAYOUTIMP  = :P_CDLAYOUTIMP AND
              NRSEQTABELAY = :P_NRSEQTABELAY
            ORDER BY
              NRSEQVALLAY ASC
    ";
    
    $nomeTabela = 'CONSUMIDOR'; // aqui tambem é necessaria uma verificacao se for utilizar mais funcoes alem de cadastro de consumidors
    $params = [
        ':P_CDLAYOUTIMP'  => $conditions['CDLAYOUTIMP'],
        ':P_NRSEQTABELAY' => $conditions['NRSEQTABELAY']
    ];
    
    return $this->entityManager->getConnection()->fetchAll($sql, $params);
	}
	
	public function addValLayoutImp($conditions) {
      // Obter o próximo valor de NRSEQVALLAY
      $sqlMaxNrSeqValLay = "SELECT MAX(NRSEQVALLAY) AS NRSEQVALLAY
                            FROM VALLAYOUTIMP
                            WHERE CDLAYOUTIMP = :P_CDLAYOUTIMP
                              AND NRSEQTABELAY = :P_NRSEQTABELAY";
  
      $paramsMax = [
          ':P_CDLAYOUTIMP' => $conditions['CDLAYOUTIMP'],
          ':P_NRSEQTABELAY' => $conditions['NRSEQTABELAY']
      ];
  
      $result = $this->entityManager->getConnection()->fetchAssociative($sqlMaxNrSeqValLay, $paramsMax);
      $stNrSeqValLay = empty($result['NRSEQVALLAY']) ? '0' : $result['NRSEQVALLAY'];
  
      // Preparar os parâmetros para o insert
      $newNrSeqValLay = str_pad((string)((int)$stNrSeqValLay + 1), 10, '0', STR_PAD_LEFT);
  
      $sqlInsert = "INSERT INTO VALLAYOUTIMP
                    (CDLAYOUTIMP, NRSEQTABELAY, NRSEQVALLAY, NRPOSINIVALLAY, NRTAMVALLAY, DSVALVALLAY)
                    VALUES
                    (:CDLAYOUTIMP, :NRSEQTABELAY, :NRSEQVALLAY, :NRPOSINIVALLAY, :NRTAMVALLAY, :DSVALVALLAY)";
  
      $paramsInsert = [
          ':CDLAYOUTIMP' => $conditions['CDLAYOUTIMP'],
          ':NRSEQTABELAY' => $conditions['NRSEQTABELAY'],
          ':NRSEQVALLAY' => $newNrSeqValLay,
          ':NRPOSINIVALLAY' => $conditions['NRPOSINIVALLAY'],
          ':NRTAMVALLAY' => $conditions['NRTAMVALLAY'],
          ':DSVALVALLAY' => $conditions['DSVALVALLAY']
      ];
  
      // Executar o insert
      $this->entityManager->getConnection()->executeQuery($sqlInsert, $paramsInsert);
  }
  
  public function updateValLayoutImp($conditions) {
    $sql = "UPDATE VALLAYOUTIMP
            SET
              NRPOSINIVALLAY = :NRPOSINIVALLAY,
              NRTAMVALLAY = :NRTAMVALLAY,
              DSVALVALLAY = :DSVALVALLAY
            WHERE
              CDLAYOUTIMP = :OLD_CDLAYOUTIMP AND
              NRSEQTABELAY = :OLD_NRSEQTABELAY AND
              NRSEQVALLAY = :OLD_NRSEQVALLAY";

    $params = [
        ':NRPOSINIVALLAY' => $conditions['NRPOSINIVALLAY'],
        ':NRTAMVALLAY' => $conditions['NRTAMVALLAY'],
        ':DSVALVALLAY' => $conditions['DSVALVALLAY'],
        ':OLD_CDLAYOUTIMP' => $conditions['CDLAYOUTIMP'],
        ':OLD_NRSEQTABELAY' => $conditions['NRSEQTABELAY'],
        ':OLD_NRSEQVALLAY' => $conditions['NRSEQVALLAY']
    ];

    $this->entityManager->getConnection()->executeQuery($sql, $params);
  }
  
  public function deleteValidacao($conditions) {
    $sql = "DELETE FROM VALLAYOUTIMP
            WHERE
              CDLAYOUTIMP = :OLD_CDLAYOUTIMP AND
              NRSEQTABELAY = :OLD_NRSEQTABELAY AND
              NRSEQVALLAY = :OLD_NRSEQVALLAY";

    $params = [
        ':OLD_CDLAYOUTIMP' => $conditions['CDLAYOUTIMP'],
        ':OLD_NRSEQTABELAY' => $conditions['NRSEQTABELAY'],
        ':OLD_NRSEQVALLAY' => $conditions['NRSEQVALLAY']
    ];

    $this->entityManager->getConnection()->executeQuery($sql, $params);
  }

  // Parametros importacao automatica
  
  public function checkFuncaoConsumidor($CDLAYOUTIMP) {
    $sql = "SELECT * FROM FUNLAYOUTIMP
            WHERE IDFUNARQLAY = '008'
              AND CDLAYOUTIMP = :CDLAYOUTIMP";

    $params = [
        ':CDLAYOUTIMP' => $CDLAYOUTIMP
    ];

    $result = $this->entityManager->getConnection()->fetchAll($sql, $params);
    return !empty($result);
  }

  public function findLayoutData($CDLAYOUTIMP) {
    $sql = "SELECT
              CDLAYOUTIMP, NMLAYOUTIMP, IDSEPARCAMPO, IDCARACDELIM,
              IDCARACDECIM, IDCARACSTRIN, IDSISTEMAIMP, IDSISTEMORIG,
              DSDIRARQIMPCONS, IDPERIODIMPCONS, HRIMPAUTOCONS,
              IDTPCLIEIMPCONS, CDCLIEIMPCONS, DSDIRARQPHP, DSDIRINSTALAPHP,
              CDFILIAL
            FROM
              LAYOUTIMP
            WHERE
              CDLAYOUTIMP = :P_CDLAYOUTIMP";

    $params = [
        ':P_CDLAYOUTIMP' => $CDLAYOUTIMP
    ];

    return $this->entityManager->getConnection()->fetchAll($sql, $params);
  }
  
  public function selectClienteLayout($conditions) {
    $sql = "SELECT DISTINCT CL.CDCLIENTE, CL.NRINSJURCLIE, CL.NMRAZSOCCLIE, CL.IDTPIJURCLIE
            FROM CLIENTE CL, CLIENFILIAL CF
            WHERE ((CF.CDFILIAL = :P_CDFILIAL) OR (:P_TCDFILIAL = 'T'))
              AND (CL.CDCLIENTE = CF.CDCLIENTE(+))
              AND (
                  CL.NRINSJURCLIE LIKE :P_SEARCH_FILTER
                  OR CL.CDCLIENTE LIKE :P_SEARCH_FILTER
                  OR CL.NMRAZSOCCLIE LIKE :P_SEARCH_FILTER
                  OR :T_P_SEARCH_FILTER = 'T'
              )
            ORDER BY CL.NRINSJURCLIE";

    
    $TCDFILIAL = null;
    if (empty($conditions['CDFILIAL'])) {
      $TCDFILIAL = 'T';
    }
  
    $TSEARCH = 'T';
    $conditions['P_SEARCH_FILTER'] = null;
    if (isset($conditions["NRINSJURCLIE|CDCLIENTE|NMRAZSOCCLIE"]) && isset($conditions["NRINSJURCLIE|CDCLIENTE|NMRAZSOCCLIE"][0]) && isset($conditions["NRINSJURCLIE|CDCLIENTE|NMRAZSOCCLIE"][0]["_ALL"])) {
       $TSEARCH = null;
       $conditions['P_SEARCH_FILTER'] = $conditions["NRINSJURCLIE|CDCLIENTE|NMRAZSOCCLIE"][0]["_ALL"];
    }
    
    $params = [
        ':P_CDFILIAL' => $conditions['CDFILIAL'],
        ':P_TCDFILIAL' => $TCDFILIAL,
        ':P_SEARCH_FILTER' =>  $conditions['P_SEARCH_FILTER'],
        ':T_P_SEARCH_FILTER' =>  $TSEARCH
    ];
    
    $result = $this->entityManager->getConnection()->fetchAll($sql, $params);
    return $result;
  }
  
  public function updateLayoutImp($conditions) {
    $sql = "UPDATE LAYOUTIMP
            SET
              NMLAYOUTIMP = :NMLAYOUTIMP,
              IDSEPARCAMPO = :IDSEPARCAMPO,
              IDCARACDELIM = :IDCARACDELIM,
              IDCARACDECIM = :IDCARACDECIM,
              IDCARACSTRIN = :IDCARACSTRIN,
              IDSISTEMAIMP = :IDSISTEMAIMP,
              IDSISTEMORIG = :IDSISTEMORIG,
              CDFILIAL = :CDFILIAL,
              DSDIRARQIMPCONS = :DSDIRARQIMPCONS,
              IDPERIODIMPCONS = :IDPERIODIMPCONS,
              HRIMPAUTOCONS = :HRIMPAUTOCONS,
              IDTPCLIEIMPCONS = :IDTPCLIEIMPCONS,
              CDCLIEIMPCONS = :CDCLIEIMPCONS,
              DSDIRARQPHP = :DSDIRARQPHP,
              DSDIRINSTALAPHP = :DSDIRINSTALAPHP
            WHERE
              CDLAYOUTIMP = :OLD_CDLAYOUTIMP";

    $params = [
        ':NMLAYOUTIMP' => $conditions['NMLAYOUTIMP'],
        ':IDSEPARCAMPO' => $conditions['IDSEPARCAMPO'],
        ':IDCARACDELIM' => $conditions['IDCARACDELIM'],
        ':IDCARACDECIM' => $conditions['IDCARACDECIM'],
        ':IDCARACSTRIN' => $conditions['IDCARACSTRIN'],
        ':IDSISTEMAIMP' => $conditions['IDSISTEMAIMP'],
        ':IDSISTEMORIG' => $conditions['IDSISTEMORIG'],
        ':CDFILIAL' => $conditions['CDFILIAL'],
        ':DSDIRARQIMPCONS' => $conditions['DSDIRARQIMPCONS'],
        ':IDPERIODIMPCONS' => $conditions['IDPERIODIMPCONS'],
        ':HRIMPAUTOCONS' => $conditions['HRIMPAUTOCONS'],
        ':IDTPCLIEIMPCONS' => $conditions['IDTPCLIEIMPCONS'],
        ':CDCLIEIMPCONS' => $conditions['CDCLIEIMPCONS'],
        ':DSDIRARQPHP' => $conditions['DSDIRARQPHP'],
        ':DSDIRINSTALAPHP' => $conditions['DSDIRINSTALAPHP'],
        ':OLD_CDLAYOUTIMP' => $conditions['CDLAYOUTIMP']
    ];

    $this->entityManager->getConnection()->executeQuery($sql, $params);
  }

  
  //////////////////////////////////
	// EXPORTAÇÃO/IMPORTAÇÃO LAYOUT //
	//////////////////////////////////
	
  public function getLayoutImp($CDLAYOUTIMP) {
      $sql = "SELECT
                CDLAYOUTIMP, NMLAYOUTIMP, IDSEPARCAMPO, IDCARACDELIM,
                IDCARACDECIM, IDCARACSTRIN, IDSISTEMAIMP, IDSISTEMORIG
              FROM
                LAYOUTIMP
              WHERE
                CDLAYOUTIMP = :P_CDLAYOUTIMP";
      $params = [':P_CDLAYOUTIMP' => $CDLAYOUTIMP];
      return $this->entityManager->getConnection()->fetchAll($sql, $params);
  }

  public function getTabLayoutImp($CDLAYOUTIMP) {
      $sql = "SELECT
                CDLAYOUTIMP, NRSEQTABELAY, NMTABELABD, NRORDIMPLAY, NMARQLAYIMP
              FROM
                TABLAYOUTIMP
              WHERE
                CDLAYOUTIMP = :P_CDLAYOUTIMP";
      $params = [':P_CDLAYOUTIMP' => $CDLAYOUTIMP];
      return $this->entityManager->getConnection()->fetchAll($sql, $params);
  }

  public function getFunLayoutImp($CDLAYOUTIMP) {
      $sql = "SELECT
                CDLAYOUTIMP, NRSEQTABELAY, IDFUNARQLAY, IDINACONSARQIMP, IDPARALISAIMPARQ, IDREMOVEZEROESQ
              FROM
                FUNLAYOUTIMP
              WHERE
                CDLAYOUTIMP = :P_CDLAYOUTIMP";
      $params = [':P_CDLAYOUTIMP' => $CDLAYOUTIMP];
      return $this->entityManager->getConnection()->fetchAll($sql, $params);
  }

  public function getFrmtColLay() {
      $sql = "SELECT
                CDFRMTCOLLAY, DSFRMTCOLLAY
              FROM
                FRMTCOLLAY";
      return $this->entityManager->getConnection()->fetchAll($sql);
  }

  public function getColLayoutImp($CDLAYOUTIMP) {
      $sql = "SELECT
                CDLAYOUTIMP, NRSEQTABELAY, IDFUNARQLAY, NRSEQCOLULAY, NRPOSICOLLAY,
                NRTAMCOLLAY, NRCASASDECIM, DSDEFACOLLAY, IDGERSEQCOLU, IDTDADCOLLAY,
                IDGERCODCOLU, CDFRMTCOLLAY, NMTABELAIMP, NMCOLUNAIMP, DSCONCATESQ,
                DSCONCATDIR
              FROM
                COLLAYOUTIMP
              WHERE
                CDLAYOUTIMP = :P_CDLAYOUTIMP";
      $params = [':P_CDLAYOUTIMP' => $CDLAYOUTIMP];
      return $this->entityManager->getConnection()->fetchAll($sql, $params);
  }

  public function getValLayoutImp($CDLAYOUTIMP) {
      $sql = "SELECT
                CDLAYOUTIMP, NRSEQTABELAY, NRSEQVALLAY, NRPOSINIVALLAY, NRTAMVALLAY, DSVALVALLAY
              FROM
                VALLAYOUTIMP
              WHERE
                CDLAYOUTIMP = :P_CDLAYOUTIMP";
      $params = [':P_CDLAYOUTIMP' => $CDLAYOUTIMP];
      return $this->entityManager->getConnection()->fetchAll($sql, $params);
  }
  
  // importacao
  public function insertLayoutImp($line) {
    // Verifica se o layout já foi importado
    $checkSql = "SELECT CDLAYOUTIMP FROM LAYOUTIMP WHERE CDLAYOUTIMP = :P_CDLAYOUTIMP";
    $checkParams = [':P_CDLAYOUTIMP' => trim(substr($line, 2, 10))];
    $exists = $this->entityManager->getConnection()->fetchAll($checkSql, $checkParams);

    if (!empty($exists)) {
        throw new \Exception('O layout já se encontra importado.');
    }

    // Insere o layout
    $sql = "INSERT INTO LAYOUTIMP
              (CDLAYOUTIMP, NMLAYOUTIMP, IDSEPARCAMPO, IDCARACDELIM,
               IDCARACDECIM, IDCARACSTRIN, IDSISTEMAIMP, IDSISTEMORIG, CDFILIAL)
            VALUES
              (:CDLAYOUTIMP, :NMLAYOUTIMP, :IDSEPARCAMPO, :IDCARACDELIM,
               :IDCARACDECIM, :IDCARACSTRIN, :IDSISTEMAIMP, :IDSISTEMORIG, :CDFILIAL)";
    $params = [
        ':CDLAYOUTIMP'   => trim(substr($line, 2, 10)),
        ':NMLAYOUTIMP'   => trim(substr($line, 12, 50)),
        ':IDSEPARCAMPO'  => trim(substr($line, 62, 1)),
        ':IDCARACDELIM'  => trim(substr($line, 63, 1)),
        ':IDCARACDECIM'  => trim(substr($line, 64, 1)),
        ':IDCARACSTRIN'  => trim(substr($line, 65, 1)),
        ':IDSISTEMAIMP'  => trim(substr($line, 66, 5)),
        ':IDSISTEMORIG'  => trim(substr($line, 71, 5)),
        ':CDFILIAL'      => null 
    ];
    return $this->entityManager->getConnection()->executeQuery($sql, $params);
  }

  public function insertTabLayoutImp($line) {
    $sql = "INSERT INTO TABLAYOUTIMP
              (CDLAYOUTIMP, NRSEQTABELAY, NMARQLAYIMP, NMTABELABD, NRORDIMPLAY)
            VALUES
              (:CDLAYOUTIMP, :NRSEQTABELAY, :NMARQLAYIMP, :NMTABELABD, :NRORDIMPLAY)";
    
    $params = [
        ':CDLAYOUTIMP'   => trim(substr($line, 2, 10)),
        ':NRSEQTABELAY'  => trim(substr($line, 12, 10)),
        ':NMTABELABD'    => trim(substr($line, 22, 30)),
        ':NRORDIMPLAY'   => trim(substr($line, 52, 5)),
        ':NMARQLAYIMP'   => trim(substr($line, 57, 250))
    ];
    return $this->entityManager->getConnection()->executeQuery($sql, $params);
  }

  public function insertFunLayoutImp($line) {
    $sql = "INSERT INTO FUNLAYOUTIMP
              (CDLAYOUTIMP, NRSEQTABELAY, IDFUNARQLAY, IDINACONSARQIMP, IDPARALISAIMPARQ, IDREMOVEZEROESQ)
            VALUES
              (:CDLAYOUTIMP, :NRSEQTABELAY, :IDFUNARQLAY, :IDINACONSARQIMP, :IDPARALISAIMPARQ, :IDREMOVEZEROESQ)";
    
    $params = [
        ':CDLAYOUTIMP'      => trim(substr($line, 2, 10)),
        ':NRSEQTABELAY'     => trim(substr($line, 12, 10)),
        ':IDFUNARQLAY'      => trim(substr($line, 22, 3)),
        ':IDINACONSARQIMP'  => trim(substr($line, 25, 1)),
        ':IDPARALISAIMPARQ' => trim(substr($line, 26, 1)),
        ':IDREMOVEZEROESQ'  => trim(substr($line, 27, 1))
    ];
    return $this->entityManager->getConnection()->executeQuery($sql, $params);
  }
  
  public function insertFrmtColLay($line) {
    $checkSql = "SELECT CDFRMTCOLLAY FROM FRMTCOLLAY WHERE CDFRMTCOLLAY = :P_CDFRMTCOLLAY";
    $checkParams = [':P_CDFRMTCOLLAY' => trim(substr($line, 2, 3))];
    $exists = $this->entityManager->getConnection()->fetchAll($checkSql, $checkParams);

    if (empty($exists)) {
        $sql = "INSERT INTO FRMTCOLLAY (CDFRMTCOLLAY, DSFRMTCOLLAY)
                VALUES (:CDFRMTCOLLAY, :DSFRMTCOLLAY)";
        $params = [
            ':CDFRMTCOLLAY' => trim(substr($line, 2, 3)),
            ':DSFRMTCOLLAY' => trim(substr($line, 5, 50))
        ];
        return $this->entityManager->getConnection()->executeQuery($sql, $params);
    }
  }
  
  public function insertColLayoutImpImport($line) {
    $sql = "INSERT INTO COLLAYOUTIMP
              (CDLAYOUTIMP, NRSEQTABELAY, IDFUNARQLAY, NRSEQCOLULAY, NMTABELAIMP, NMCOLUNAIMP,
               NRPOSICOLLAY, NRTAMCOLLAY, NRCASASDECIM, CDFRMTCOLLAY, IDGERSEQCOLU, IDTDADCOLLAY,
               IDGERCODCOLU, DSDEFACOLLAY, DSCONCATESQ, DSCONCATDIR)
            VALUES
              (:CDLAYOUTIMP, :NRSEQTABELAY, :IDFUNARQLAY, :NRSEQCOLULAY, :NMTABELAIMP, :NMCOLUNAIMP,
               :NRPOSICOLLAY, :NRTAMCOLLAY, :NRCASASDECIM, :CDFRMTCOLLAY, :IDGERSEQCOLU, :IDTDADCOLLAY,
               :IDGERCODCOLU, :DSDEFACOLLAY, :DSCONCATESQ, :DSCONCATDIR)";
    
    $params = [
        ':CDLAYOUTIMP'   => trim(substr($line, 2, 10)),
        ':NRSEQTABELAY'  => trim(substr($line, 12, 10)),
        ':IDFUNARQLAY'   => trim(substr($line, 22, 3)),
        ':NRSEQCOLULAY'  => trim(substr($line, 25, 10)),
        ':NRPOSICOLLAY'  => trim(substr($line, 35, 15)),
        ':NRTAMCOLLAY'   => trim(substr($line, 50, 15)),
        ':NRCASASDECIM'  => trim(substr($line, 65, 15)),
        ':DSDEFACOLLAY'  => trim(substr($line, 80, 50)),
        ':IDGERSEQCOLU'  => trim(substr($line, 130, 1)),
        ':IDTDADCOLLAY'  => trim(substr($line, 131, 1)),
        ':IDGERCODCOLU'  => trim(substr($line, 132, 1)),
        ':CDFRMTCOLLAY'  => trim(substr($line, 133, 3)),
        ':NMTABELAIMP'   => trim(substr($line, 136, 30)),
        ':NMCOLUNAIMP'   => trim(substr($line, 166, 30)),
        ':DSCONCATESQ'   => trim(substr($line, 196, 50)),
        ':DSCONCATDIR'   => trim(substr($line, 246, 50))
    ];
    return $this->entityManager->getConnection()->executeQuery($sql, $params);
  }

  public function insertValLayoutImp($line) {
    $sql = "INSERT INTO VALLAYOUTIMP
              (CDLAYOUTIMP, NRSEQTABELAY, NRSEQVALLAY, NRPOSINIVALLAY, NRTAMVALLAY, DSVALVALLAY)
            VALUES
              (:CDLAYOUTIMP, :NRSEQTABELAY, :NRSEQVALLAY, :NRPOSINIVALLAY, :NRTAMVALLAY, :DSVALVALLAY)";
    
    $params = [
        ':CDLAYOUTIMP'    => trim(substr($line, 2, 10)),
        ':NRSEQTABELAY'   => trim(substr($line, 12, 10)),
        ':NRSEQVALLAY'    => trim(substr($line, 22, 10)),
        ':NRPOSINIVALLAY' => trim(substr($line, 32, 10)),
        ':NRTAMVALLAY'    => trim(substr($line, 42, 10)),
        ':DSVALVALLAY'    => trim(substr($line, 52, 600))
    ];
    return $this->entityManager->getConnection()->executeQuery($sql, $params);
  }

  
  public function beginTransaction () {
    $this->entityManager->beginTransaction();
  }

  public function commitTransaction () {
    $this->entityManager->commit();
  }

  public function rollBackTransaction () {
    $this->entityManager->rollback();
  }
  
  public function adqColunaImp() {
    $sql = "SELECT NMTABELABD
            FROM COLUNA";
            
    return $this->entityManager->getConnection()->fetchAll($sql);
  }
  
  public function adqTabelaImp () {
    $sql = "SELECT NMTABELABD, DSTABELABD, IDCRIADOTAB
            FROM TABELA
            ORDER BY NMTABELABD";
            
    return $this->entityManager->getConnection()->fetchAll($sql);
  }
  
  ///////////////////////
	// ATUALIZAR COLUNAS //
	///////////////////////
	
  public function insTabela($nomeTabela) {
    $sql = "INSERT INTO TABELA (NMTABELABD, IDCRIADOTAB)
            (SELECT TABLE_NAME, 'S' AS IDCRIADO
             FROM USER_TABLES
             WHERE TABLE_NAME = :P_NMTABELA
             MINUS
             SELECT NMTABELABD, 'S' AS IDCRIADO
             FROM TABELA)";
            
    $params = [':P_NMTABELA' => $nomeTabela];
    return $this->entityManager->getConnection()->executeQuery($sql, $params);
  }
  
  public function adqTabela($nomeTabela) {
    $sql = "SELECT NMTABELABD, DSTABELABD, IDCRIADOTAB
            FROM TABELA
            WHERE NMTABELABD = :P_NMTABELA
            ORDER BY NMTABELABD";
            
    $params = [':P_NMTABELA' => $nomeTabela];
    return $this->entityManager->getConnection()->fetchAll($sql, $params);
  }

  public function updColunaS($nomeTabela) {
    $sql = "UPDATE COLUNA
            SET IDCRIADOCOL = 'S'
            WHERE (UPPER(NMTABELABD) = :P_NMTABELA) AND
                  (NMTABELABD, NMCOLUNA) IN
                  (SELECT TABLE_NAME, COLUMN_NAME
                   FROM ALL_TAB_COLUMNS
                   WHERE UPPER(TABLE_NAME) = :P_NMTABELA)";
                   
    $params = [':P_NMTABELA' => $nomeTabela];
    return $this->entityManager->getConnection()->executeQuery($sql, $params);
  }

  public function updColunaN($nomeTabela) {
    $sql = "UPDATE COLUNA
            SET IDCRIADOCOL = 'N'
            WHERE (UPPER(NMTABELABD) = :P_NMTABELA) AND
                  (NMTABELABD, NMCOLUNA) NOT IN
                  (SELECT TABLE_NAME, COLUMN_NAME
                   FROM ALL_TAB_COLUMNS
                   WHERE UPPER(TABLE_NAME) = :P_NMTABELA)";
                   
    $params = [':P_NMTABELA' => $nomeTabela];
    return $this->entityManager->getConnection()->executeQuery($sql, $params);
  }
  
  public function insColuna($nomeTabela) {
    $procedure = new StoredProcedure($this->entityManager->getConnection(), 'INSERTCOLUMNS');
    $procedure->addParam(new Param('P_NMTABELA', Param::PARAM_INPUT, $nomeTabela, Param::PARAM_TYPE_STR));
    $procedure->execute();
  }


}